#include <iostream>
#include <vector>

using namespace std;

template <typename Kol> void ispis(Kol k){
	cout<<"Ispis kolekcije"<<endl;
	for(typename Kol::iterator it=k.begin(); it!=k.end(); it++){
		cout<<(*it)<<endl;
	}
}

template <typename Kol, typename T> void ucitaj(Kol &k){
	cout<<"Broj elemenata: "<<endl;
	int n;
	T x;
	cin>>n;
	for(int i=0; i<n; i++){
		cin>>x;
		k.push_back(x);
	}
}

void povecajZa1(vector<int> &k){
	for(vector<int>::iterator it = k.begin(); it!=k.end(); it++){
		(*it)=(*it)+1;		
	}
}

//umesto da pisemo sada zasebne funkcije za:
// inkrementaciju svih el. kolekcije, kvadriranje...
// mozemo da napisemo jednu funkciju viseg reda
// koja prosledjenu unarnu transformaciju primenjuje
// nad svim elementima kolekcije
void mapirajInt(vector<int> &k, int (*f)(int)){
	for(vector<int>::iterator it = k.begin(); it!=k.end(); it++){
		(*it)=f(*it);		
	}
}

int ink(int x){ return x+1;}
int kv(int x){ return x*x;}
int kub(int x){ return x*x*x;}
int ink3(int x){ return x+3; }

template <int k> inkk(int x){ return x+k; }

//nastavljamo uopstavanje tako da moze da se primeni
//nad bilo kojim tipom podatka inad bilo kojim tipom kolekcije
template <typename Kol, typename T>
void mapiraj(Kol &k, T (*f)(T)){
	for(typename Kol::iterator it = k.begin(); it!=k.end(); it++){
		(*it)=f(*it);		
	}
}

template <typename Kol, typename Predikat>
void mapiraj(Kol &k, Predikat p){
	for(typename Kol::iterator it = k.begin(); it!=k.end(); it++){
		//nad funkcionalom koji prosledjujemo
		// na ovaj nacin je moguce simulirati primenu
		// funkcije kao da je to prava funkcija, a ne
		// objekat
		(*it)=p(*it);		
	}
}

class InkFunkcionalInt{
	private:
		int _k;
	public:
		InkFunkcionalInt(int k){
			_k=k;
		}
		// redefinisemo operator primene funkcije
		// koji omogucava posle objektu da se ponasa
		// kao funkcija za prosledjeni argument
		// i sto je najbolje :) sada imamo dinamicko k
		int operator()(int x){
			return x+_k;
		}
};

template < class T>
class InkFunkcional{
	private:
		T _k;
	public:
		InkFunkcional(T k){
			_k=k;
		}
		
		// sada mozemo da primenjujemo "inkrementaciju"
		// za razlicite tipove podataka, naravno njena 
		// interpretacija zavisi od tipa do tipa, npr. 
		// kod 3D tacaka bi ovo moglo da se interpretira
		// kao pomeranje za neki korisnicki zadat vektor
		// pomeraja
		T operator()(T x){
			return x+_k;
		}
};

int main(int argc, char * argv[]){
	vector<int> v1;
	ucitaj< vector<int>, int >(v1);
	ispis(v1);
	povecajZa1(v1);
	ispis(v1);
	mapirajInt(v1,ink);
	ispis(v1);
	mapirajInt(v1,kv);
	ispis(v1);
	mapiraj(v1,kv);
	ispis(v1);
	//korist od sablon unarne funkcije za inkrementaciju
	// je da ne moramo da pisemo 10 razl. verzija una. 
	// funk. za inkr. npr. ink1, ink2, ink17...
	// vec mozemo ovako:
	mapiraj(v1,inkk<3>);
	ispis(v1);
	// ali i dalje ne mogu od korisnika da trazim da unese
	// k pa da onda pozovome mapiraj(v1,inkk<k>); 
	// potpuno dinamicko resenje koje bi omogucavalo 
	// da korisnik u fazi izvrsavanja parametrizuje 
	// tu unarnu funkciju je pomocu funkcionala
	cout<<"Unesi k: ";
	int k;
	cin>>k;
	InkFunkcionalInt funkInk(k);
	mapiraj(v1,funkInk);
	ispis(v1);
	InkFunkcional<int> funkInkOpsti(k);
	mapiraj(v1,funkInkOpsti);
	ispis(v1);
	return 0;
}
